package Bloyd;

#
# $Revision: 1.0a $
# $Author: Jon $
# $WWW: www.tech3software.com
# $Date: 1/13/03 9:47PM $
#
#
#

=pod

=head1 NAME

Bloyd - Perl extension for a simple AIM-to-IRC portal.

=head1 SYNOPSIS

  use Bloyd;

  my $bloyd = Bloyd->new('irc.hostname.com',	# irc server address	
			 6667,			# irc server port
			 'bloydian',		# irc nick
			 ['#chat','#bloyd],	# irc channel[s]
			 'somescreenname',	# aim screenname
			 'somepass',		# aim password
		         );
  $bloyd->start;

=head1 DESCRIPTION

This module implements an OO interface to the Aol Instant Messenger TOC protocol.

This version contains not much more than hacked code that merely connects
to the aol TOC servers and acts on instant messages.

=cut
use Class::Struct;	# so we can use structures =)
use IO::Socket;		# for socket connection[s]
use IO::Select;		# ...
use IO::Handle;		# .
use Net::AIM;		# for the aim connection
use strict;

sub new {
	my $proto = shift;
        my $class = ref($proto) || $proto;
	my $self = {};

	bless my $self  = {
            	IRC_ADDR	=> shift || undef, # irc server
            	IRC_PORT	=> shift || undef, # irc port
            	IRC_NICK	=> shift || undef, # irc nick
            	IRC_CHAN	=> shift || [],    # irc channel[s] 
            	AIM_NICK	=> shift || undef, # aim screenname
            	AIM_PASS	=> shift || undef, # aim password
            	AIM_REMOTE 	 => [],		   # remote aim users
            	IRC		=> undef, 	   # irc socket object
            	AIM		=> undef,	   # net::aim object
            	RNDSTR		=> undef,	   # random string
            	CODE_R		=> undef,	   # respond to irc code
            	
        },$class;

	return $self;
} sub start {
	my $self = shift;
		
	my $child = fork();
	if ($child) { # parent process		
		# new aim
		my $aim = new Net::AIM;
	
		$aim->newconn(  Screenname => $self->{AIM_NICK},
		 	        Password => $self->{AIM_PASS},
	 		        AutoReconnect => 1
		 	     ) or die;
	
		$self->aim($aim);
	
		my $conn = $aim->getconn();
        
        	$conn->set_handler('error',    \&on_error);
        	$conn->set_handler('im_in',    \&on_im);
        	$conn->set_handler('nick',     \&on_nick);
        	$conn->set_handler('eviled',   \&on_eviled);
        	$conn->set_handler('config',   \&on_config);
		
        	$aim->start;
	} else {	  # child process
		# new irc		
		my $irc = IO::Socket::INET->new(PeerAddr => $self->{IRC_ADDR},
                                	PeerPort => $self->{IRC_PORT},
                                	Proto => "tcp" ) or die "Failed Connecting to IRC Server! Please Check your Internet Connection!\n";
		if ($irc) {
			$self->irc($irc);
		
			srand(time);
			my $rnd = int(rand(time));
	
			$irc->send("113,".$self->{IRC_PORT}." : USERID : UNIX : Bloyd-The Lazy Ass\r\n"); 
        		$irc->send("PASS $rnd\r\n");
        		$irc->send("NICK ".$self->{IRC_NICK}."\r\n");
        		$irc->send("USER ".$self->{IRC_NICK}." $rnd ".$self->{IRC_ADDR}." : ".$self->{IRC_NICK}."\r\n");
		
		
			while ($irc->recv(my $buff,128)) {
        			my ($what,$remote,$host,$type,$data) = split(/^:(\w+)!(.+)\s+(\w+)\s+(\w+)$/,$buff);
        	
        			$self->code_r($buff);
        		
        			my $aim = $self->aim;
			
				if ($type eq "PRIVMSG") { #a message of some kind
					my ($from,$msg) = split(/^(\w+):\s+(\w+)/,$data);
			
					foreach my $to_whom (@{ $self->{AIM_REMOTE} }) {
						$aim->send_im($to_whom,"<b>&lt;$from/$remote&gt;</b> $msg");
					}			
				} elsif ($type eq "JOIN") { #someone joined the channel
                       			my $where = split(/^\s+:(.+)/,$data);
                        
                        		foreach my $to_whom (@{ $self->{AIM_REMOTE} }) {
						$aim->send_im($to_whom,"<i>*$remote has joined $where*</i>");
					}
                       		
				} elsif ($type eq "QUIT") { #someone just quit
					my $what = split(/^:\s+(.+)/,$data);
			
					foreach my $to_whom (@{ $self->{AIM_REMOTE} }) {
						$aim->send_im($to_whom,"<i>*$remote has quit ($what)*</i>");
					}
				}
		
				#so we don't time out =)
        			if (my $pong =~ /PING\s+:\s*(\w+)/) {
					$irc->send("PONG $pong\r\n");
				}
       			}
       		}
	}	
}

sub irc_addr {
	my $self = shift;
	if (@_) { $self->{IRC_ADDR} = shift; }
	
	return $self->{IRC_ADDR};
} sub irc_port {
	my $self = shift;
	if (@_) { $self->{IRC_PORT} = shift; }
	
	return $self->{IRC_PORT};
} sub irc_nick {
	my $self = shift;
	if (@_) { 
		$self->{IRC_NICK} = shift; 
		$self->{IRC_NICK} =~ s/ //;
	}
	
	return $self->{IRC_NICK};
} sub irc_chan {
	my $self = shift;
        if (@_) { @{ $self->{IRC_CHAN} } = @_ }
        
        return @{ $self->{IRC_CHAN} };
} sub aim_nick {
	my $self = shift;
	if (@_) { 
		$self->{AIM_NICK} = shift; 
		$self->{AIM_NICK} =~ s/ //;
	}
	
	return $self->{AIM_NICK};
} sub aim_pass {
	my $self = shift;
	if (@_) { $self->{AIM_PASS} = shift; }
	
	return $self->{AIM_PASS};
} sub aim_remote {
	my $self = shift;
	my @remote = @{ $self->{AIM_REMOTE} };
	
	return @remote;	
} sub irc {
	my $self = shift;
	if (@_) { $self->{IRC} = shift; }
	
	return $self->{IRC};
} sub aim {
	my $self = shift;
	if (@_) { $self->{AIM} = shift; }
	
	return $self->{AIM};
} 

#-------------
# IRC Methods
sub code_r {
	my $self = shift;
	my ($buff) = @_;
	my ($server,$code,$our_nick) = split(/^:(\w+)\s+(\d+)\s+(\w+)/,$buff);
	
	if (defined($code)) {
		my $irc = $self->irc;
		my $aim = $self->aim;
				
		 if ($code == 372 || $code == 376) { 
                	foreach my $chan (@{ $self->{IRC_CHAN} }) { $irc->send("JOIN $chan\r\n"); } 
                 } elsif ($code == 433 || $code == 436) { #"<nick> :Nickname is already in use"
                 	my $new_nick = $self->rndstr;
                 	$irc->send("NICK $new_nick\r\n");
                 }
	}
	return;		
} sub rndstr {
	my $self = shift;
	
	my $chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789[]_-^";
	my ($cstrlen,$cpos,$rnds);
	$cstrlen = 0;
	
	do {
		$cpos = int(rand(length($chars)) + 1);
		$rnds .= substr($chars,$cpos,$cpos+1);
	} until ($cstrlen = 9);
	$self->rndstr($rnds);
	
	return $self->{RNDSTR};
}

#-------------
# AIM Methods
sub aim_add_remote {
	my $self = shift;
	my ($nick) = @_;
	
	foreach my $element (@{ $self->{AIM_REMOTE} }) {
		if ($element ne $nick) {
			push(@{ $self->{AIM_REMOTE} },$nick);
			last;
		}
	}

	return @{ $self->{AIM_REMOTE} };
} sub aim_rm_remote { 
	my $self = shift;
	my ($nick) = @_;
	
	for (my $i = 0; $i < @{ $self->{AIM_REMOTE} };$i++) {
		if ($self->{AIM_REMOTE}[$i] eq $nick) {
			splice(@{ $self->{AIM_REMOTE} },$i,1);
			last;	
		}	
	}
	
	return @{ $self->{AIM_REMOTE} };
}

#---------------------------
# net::aim event portion
# . .
# since this script uses
# the net::aim module, 
# you'll have to download 
# it to use this script.
#
# you can download net::aim
# at www.cpan.org.
#
# -thanks
sub on_im {
	my ($self, $evt, $from, $to) = @_;
  	my $args = $evt->args();
  	my ($nick, $auto_msg, $msg) = @$args;
  	
  	#meh, need to remove html
  	$msg =~ s/<[^>]+>//g;
	$msg =~ s/^\s+//g;
  	
  	my ($cmd,$argv1,$argv2) = ($msg =~ /\.(\S+)\s*(\S*)/);

  	if (defined($cmd)) {
  		
  		last;	
  	}
     	$self->send_im($nick,"Hello, I'm Bloyd (The Lazy Ass v1.0a). I'm in my alpha stage (guess it's kind of like I'm in puberty :-\\), so I have no <i>real</i> \"features\". Allthough you can go <a href=\"http://www.tech3software.com\">here</a> for more information about me!");

} sub on_nick {
	my ($self, $evt, $from, $to) = @_;
	my $args = $evt->args();
	my $nick = $args->[0];
	
	print "Logged on Successfully!\n";
} sub on_config {
	my ($self, $evt, $from, $to) = @_;
	my $str = shift @{$evt->args()};
	
	$self->set_config_str($str, 1);
	
	$self->set_info("You know what you want, and we know you want 'Bloyd: The Lazy Ass v1.0a'<br><br>By <a href=http://www.tech3software.com>Tech3Software</a>");
	
	$self->send_config();
} sub on_error {
	my ($self, $evt) = @_;
	my ($error, @stuff) = @{$evt->args()};
	my $errstr = $evt->trans($error);
   
	$errstr =~ s/\$(\d+)/$stuff[$1]/ge;

}
1;